
fis = Matrix(RDF, [[1, 2, 3, 4, 1], [1, 3, 4, 1, 0], [1, 5, 7, 9, 3]])
f0 = vector(RDF, [1, 0, -1, 0, 0])
v = vector(RDF, [1.3242315355656881, 1.4242142131531, 10.12124141531]) * fis + f0

# Find an approximation f0 + y.fis of v such that y=numerators/denominator
# with denominator of specified magnitude
def near_vector(magnitude, v, f0, fis):
  assert(len(f0) == fis.ncols())
  dim = len(f0)
  beta = 1e18
  alpha = beta*magnitude*magnitude
  gamma = beta
  m=Matrix(ZZ, fis.nrows()+1, 2*dim+fis.nrows()+1)
  m[0, 0:dim] = alpha * (f0 - v)
  m[0, dim:2*dim] = gamma * f0
  m[1:, 0:dim] = alpha * fis
  m[1:, dim:2*dim] = beta * fis
  m[:, 2*dim:] = identity_matrix(ZZ, fis.nrows()+1)

  m=m.LLL()
  denominator = m[0, 2*dim]
  numerators = m.row(0)[2*dim+1:]
  if (denominator < 0):
    denominator = -denominator
    numerators = -numerators
  return (numerators, denominator)

(numerators, denominator) = near_vector(10, v, f0, fis)
assert(denominator != 0)
y = numerators/denominator
w = f0+y*fis
print numerators
print denominator
print v
print w
print (v - w).norm(2)
