load 'solve_sos_equation.sage'

indeterminates=['x', 'y', 'z']
polynomial_ring=PolynomialRing(QQ, indeterminates)
  
monomial_list=[polynomial_ring('x')^a * polynomial_ring('y')^b * polynomial_ring('z')^c for a in range(4) for b in range(4) for c in range(4) if a+b+c<=2]

lhs_polynomials=[polynomial_ring('x*y + 3*y^2 + z + x^3 + 1'), polynomial_ring('x - 2*y^2 + 5*z^3 + 2'), polynomial_ring('x^2 - z + y'), 1]
lhs_polynomials.append(-(lhs_polynomials[0]+polynomial_ring('3+(x+5*y)^2')*lhs_polynomials[1]+lhs_polynomials[2])-polynomial_ring('1+x^2'));

lhs_monomial_lists=[monomial_list for p in lhs_polynomials]
rhs_polynomial=polynomial_ring(-1)

solution = solve_sos_equation(polynomial_ring, lhs_polynomials, lhs_monomial_lists, rhs_polynomial)

def apply_sos_solution(solution, lhs_polynomials, lhs_monomial_lists):
  assert(len(solution) == len(lhs_monomial_lists))
  assert(len(solution) == len(lhs_polynomials))
  lhs_total = 0
  for (sos, poly, monomials) in zip(solution, lhs_polynomials, lhs_monomial_lists):
    lhs_total += poly * apply_sos(sos, monomials)
  return lhs_total

if solution == ():
  print 'NO SOLUTION'
else:
  assert(apply_sos_solution(solution, lhs_polynomials, lhs_monomial_lists)==rhs_polynomial)
  print 'SOLUTION'
  print 'RHS'
  print rhs_polynomial
  for i in xrange(len(lhs_polynomials)):
    print 'POLYNOMIAL', i
    print lhs_polynomials[i]
    print 'summands'
    for coeff, sos in solution[i]:
      print coeff, "*(", sum([a*b for a, b in zip(sos, lhs_monomial_lists[i])]), ")^2"
